#include "DxLib.h"
#include "Player.h"
#include "Keyboard.h"
#include "Plusproglam.h"

int WINAPI WinMain(HINSTANCE,HINSTANCE,LPSTR,int){
        ChangeWindowMode(TRUE),DxLib_Init(),SetDrawScreen( DX_SCREEN_BACK );

		Player_t Player;
        Player_Initialize(&Player);// 
		int fanc_state=0;
		configpad_t configpad;
		pad_t pad;
		Ini_3D();


        while( ScreenFlip()==0 && ProcessMessage()==0 && ClearDrawScreen()==0 ){

			switch(fanc_state){
			case 0:
                configpad_ini(&configpad);
				fanc_state=1;
				break;
			case 1:
				Keyboard_Update();
				GetHitPadStateAll(&pad,configpad,0);//DX_INPUT_PAD1
				Player_Calc(&Player,configpad,pad);
                Player_Move(&Player,pad,configpad);  // vZ
                Player_Graph(Player); // `
				break;
			default:
				break;
			}
        }

        Player_Finalize();  // I

        DxLib_End();
        return 0;
}